%define cvs 20070113

# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.19-1.2911.6.5.fc6}

%define kmod_name madwifi
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch ppc
%define smpvar smp
%endif
%ifarch i686 x86_64
%define xenvar xen
%define kdumpvar kdump
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?paevar} %{?xenvar} %{?kdumpvar}}

Name:           %{kmod_name}-kmod
Version:        0.9.3
Release:        0.1cvs%{cvs}%(echo %{kverrel} | tr - _)
Summary:        Kernel module for Atheros 802.11 wireless devices ar5210,ar5211 or ar5212

Group:          System Environment/Kernel
License:        GPL
URL:            http://www.madwifi.org/
#Source0:	http://download.sourceforge.net/madwifi/madwifi-%{version}.tar.bz2
Source0:	http://snapshots.madwifi.org/madwifi-ng/madwifi-ng-r1968-%{cvs}.tar.gz
Patch0:		http://patches.aircrack-ng.org/madwifi-ng-r1886.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  sharutils
ExclusiveArch:	i586 i686 x86_64 ppc


%description
This package contains the Multiband Atheros Driver for WiFi, a linux
device driver for 802.11a/b/g universal NIC cards - either Cardbus,
PCI or MiniPCI - that use Atheros chipsets (ar5210, ar5211, ar5212).


# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0 -n madwifi-ng-r1968-%{cvs}
#sed -i 's!#include <linux/config.h>!!' $(grep -r '#include <linux/config.h>' madwifi-%{version}/ | sed 's!:#include <linux/config.h>!!')
pushd madwifi-ng-r1968-%{cvs}
%patch0 -p1
popd

for kvariant in %{kvariants} ; do
    cp -a madwifi-ng-r1968-%{cvs} _kmod_build_$kvariant
done

%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    cd _kmod_build_$kvariant
    make KERNELPATH="${ksrc}" KERNELRELEASE=%{kverrel}${kvariant} UUDECODE=/usr/bin/uudecode modules
    cd ..
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    cd _kmod_build_$kvariant
    make KERNELPATH="${ksrc}" KERNELRELEASE=%{kverrel}${kvariant} UUDECODE=/usr/bin/uudecode DESTDIR=$RPM_BUILD_ROOT KMODPATH=/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name} install-modules 
    cd ..
done
chmod 0755 $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*


%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Sat Jan 13 2007 kwizart < kwizart at gmail.com > - 0.9.3-0.1cvs20070113
- Update to pre 0.9.3-0.1cvs20070113
- Update Patch to 1886

* Fri Dec 15 2006 kwizart < kwizart at gmail.com > - 0.9.2.1-5
- Patch injection.

* Fri Dec  8 2006 Dams <anvil[AT]livna.org> - 0.9.2.1-1
- Updated to upstream 0.9.2.1

* Sat Oct 07 2006 Thorsten Leemhuis <fedora AT leemhuis DOT info> - 0.9.2-2
- sed-away the config.h include

* Sat Aug 19 2006 Dams <anvil[AT]livna.org> - 0.9.2-2
- ppc added to ExclusiveArch

* Fri Aug 18 2006 Dams <anvil[AT]livna.org> - 0.9.2-1
- Updated to 0.9.2

* Sun Jun 11 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.0.0.20060520-7
- Invoke kmodtool with bash instead of sh.

* Sat May 20 2006 Dams <anvil[AT]livna.org> - 0.0.0.20060520-6
- Updated snapshot to 20060520

* Sun May 14 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.0.0.20060317-5
- Require version >= of madwifi-kmod-common.
- Provide madwifi-kmod instead of kmod-madwifi to fix upgrade woes (#970).

* Thu Apr 27 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.0.0.20060317-4
- Provide "kernel-modules" instead of "kernel-module" to match yum's config.

* Tue Mar 27 2006 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.0.0.20060317-3
- small adjustments to kmod specific tasks
- update kmodtool to 0.10.6

* Sat Mar 18 2006 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.0.0.20060317-2
- disable xenU build; no wireless extensions in xenU!

* Sat Mar 18 2006 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.0.0.20060317-1
- move 20060317 from release to version

* Sat Mar 18 2006 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.lvn.15.20060317
- update to 20060317
- build for ppc, too; no, don't, does not build
- drop 0.lvn
- hardcode kversion

* Sat Feb 11 2006 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.lvn.15.20060211
- split into packages for userland and kmod

* Sat Dec 03 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.lvn.11.20051130
- fix uudecode on fc3 by passing UUDECODE=/usr/bin/uudecode to make

* Sat Dec 03 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.lvn.10.20051130
- Update to 2005-11-30

* Sat Nov 19 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.lvn.9.20051114
- Update to 2005-11-14 from madwifi.org (madwifi-ng)

* Sat Nov 12 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.lvn.8.20051112
- Update to 2005-11-12

* Sat Sep 17 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.lvn.7.20050917
- Update to 2005-09-17

* Wed Jul 20 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.0-0.lvn.6.20050715
- Avoid the check for kernel-patch and kernel-config on i386 if we only build
  userland

* Fri Jul 15 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.0-0.lvn.5.20050715
- Update to 2005-07-15 (after merge of BSD branch)

* Sat Jul 09 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.0-0.lvn.4.20050709
- Update to 2005-07-09
- Support x86_64
- adjust kernel-build stuff to current livna scheme
- drop tools subpackage, just use the name "madwifi"

* Sun Jan 23 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.0-0.lvn.3.20050220
- Update to 2005-02-20
- ExclusivArch %%{ix86} for now
- Build tools also as suggested in #355 my Michael A. Peters 
  <funkyres [AT] gmail [DOT] com>  

* Sun Jan 23 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.0-0.lvn.3.20041229
- Update to 20041229 on recommendation by Gianluca Sforna

* Sun Jan 09 2005 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.0-0.lvn.2.20041127
- BR sharutils (thanks Gianluca Sforna for catching this bug)

* Fri Nov 26 2004 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> 0.0-0.lvn.1.20041127
- Initial Version
- Applied Ville Skyttä's nameing scheme from bash-completion
- Used cvs-snapshot web-location mentioned on Homepage as source
- Cause of the issue with the included HAL I choosed livna as repo.
   For details on the HAL and its distribution see:
   http://www.mattfoster.clara.co.uk/madwifi-5.htm
